#!/usr/bin/perl
use utf8;
use Encode;
use DBI;
use URI::Escape;
#use DateTime;

my $data=$ENV{'QUERY_STRING'};
#my $data='type=json';

$data =~ tr/+/ /;
$data =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1) )/ge;
my @pars = split(/&/,$data);

sub escape_sql { # sanitize ( escape )
	my ($str) = @_;
	if(defined($str)) {
		$str =~ s/\\/\\\\\\\\/go;
		$str =~ s/'/''/go; #'
		$str =~ s/%/\\\\%/go;
		$str =~ s/_/\\\\_/go;
	}
	return $str;
}
my $type = 'html'; # or json
my $client = 'unknown';
foreach( @pars ) {
	my $data = $_;
	my $name;
	my $value;
	($name,$value) = split(/=/,$data);
	if( $name eq 'type' ) {
		$type = $value;
	} elsif( $name eq 'client' ) {
		$client = $value;
	}
}
$client = escape_sql( $client );

#my $dbh = DBI->connect("dbi:SQLite:dbname=ad.db",'','',{sqlite_unicode => 1});
my $dbh = DBI->connect("dbi:SQLite:dbname=ad.db",'','');
my $sth = $dbh->prepare("SELECT COUNT(*) FROM ad");
$sth->execute;
if( my @row = $sth->fetchrow_array ) {
	my $count = $row[0];
	$sth->finish;
	if( $count > 0 ) {
		my $index = time() % $count;
		my $statement = "SELECT id, name, url, description FROM ad order by id asc LIMIT 1 OFFSET ". $index;
		$sth = $dbh->prepare( $statement );
		$sth->execute;
		if( my @row = $sth->fetchrow_array ) {
			my $id = $row[0];
			#my $name = encode('utf8', $row[1] );
			my $name = $row[1];
			my $url = $row[2];
			#my $desc = encode('utf8', $row[3] );
			my $desc = $row[3];
			$sth->finish;

			$sth = $dbh->prepare("SELECT name, width, height FROM image WHERE adid=".$id);
			$sth->execute;
			my $imgName = undef;
			my $imgW = 0;
			my $imgH = 0;
			if( $type eq 'html' ) {
				if( my @row = $sth->fetchrow_array ) {
					$sth->finish;
					$imgName = $row[0];
					$imgW = $row[1];
					$imgH = $row[2];
				}
				my $imgHtml = "";
				if( $imgW != 0 && $imgH != 0 && defined($imgName) ) {
					$imgHtml = "<a href=\"".$url."\" target=\"_top\"><img src=\"./img/".$imgName."\" width=".$imgW." height=".$imgH." border=0 align=\"left\" /></a>";
				}
				print "Content-type: text/html; charset=utf-8\n\n";
				print <<EOF;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"><style type="text/css">
<!--
body { border:1px solid #000000; }
//-->
</style><title></title></head><body>
<table border=0 frame="void" cellpadding="3"><tr><td valign="center">
EOF
				print $imgHtml;
				print "</td><td valign=\"bottom\"><font size=\"2\">";
				print "<a href=\"".$url."\" target=\"_top\">".$name."</a></font><br /><br />\n";
				print "<font size=\"1\"><a href=\"".$url."\" target=\"_top\">".$desc."</a><br />";
				print "</font></td></tr></table></body></html>";
				$dbh->disconnect;
				exit(0);
			} else {	# json
				print "Content-type: application/json; charset=utf-8\n\n";

				print "{\n";
				print "\"name\":\"".uri_escape($name)."\",\n";
				print "\"url\":\"".$url."\",\n";
				print "\"description\":\"".uri_escape($desc)."\",\n";
				print "\"image\":[\n";
				my @images = ();
				my $count = 0;
				while( my @row = $sth->fetchrow_array ) {
					my @image = @row;
					push( @images, [@image] );
					$count++;
				}
				$sth->finish;
				my $i = 0;
				for( $i = 0; $i < $count; $i++ ) {
					$imgName = $images[$i][0];
					$imgW = $images[$i][1];
					$imgH = $images[$i][2];
					print "{\n";
					print "\"filename\":\"".uri_escape($imgName)."\",\n";
					print "\"width\":".$imgW.",\n";
					print "\"height\":".$imgH."\n";
					print "}";
					if( ($i+1) < $count ) {
						print ",\n";
					} else {
						print "\n";
					}
				}

				print "]\n";
				print "}\n";
				$dbh->disconnect;
				exit(0);
			}
		}
	}
}
$dbh->disconnect;

# error empty html
print "Content-type: text/html; charset=utf-8\n\n";
print <<EOF;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head><title></title></head><body></body></html>
EOF

